package wormit;

import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;

public class Game extends Thread implements KeyListener
{
  public static final int sleep = 15;

  Wormit wormit;

  public Game(Wormit wormit)
  { this.wormit = wormit;
    for(int i = 0; i < Pressed.length; i++) Pressed[i] = false;
    for(int i = 0; i < Bonnus.length; i++) Bonnus[i] = new t_Tir();
    for(int i = 0; i < XYa.length; i++) XYa[i] = new t_coord();
    for(int i = 0; i < dbb.length; i++) dbb[i] = new t_Dir();
    for(int i = 0; i < Tir.length; i++) Tir[i] = new t_Tir();
  }

  final Color Bkc = new Color(38, 38, 88);
  final int MaxFire = 50;
  final int NORMAL = 0;
  final int PLASMA = 1;
  final int LASER = 2;
  final int FLASH = 3;
  final int na1 = 100;
  final int na2 = 80;
  final int na3 = 60;
  final int Vm = 60;

  final int ESC_KEY   = 0;
  final int Q_KEY     = 1;
  final int C_KEY     = 2;
  final int N_KEY     = 3;
  final int Y_KEY     = 4;
  final int I_KEY     = 5;
  final int P_KEY     = 6;
  final int SP_KEY    = 7;
  final int F_KEY     = 8;
  final int M_KEY     = 9;
  final int K_KEY     = 10;
  final int UP_KEY    = 11;
  final int DOWN_KEY  = 12;
  final int LEFT_KEY  = 13;
  final int RIGHT_KEY = 14;
  final int _1_KEY    = 15;
  final int _2_KEY    = 16;
  final int _3_KEY    = 17;

  int Xs, Ys, Vs, BVs, arme, nbFlash;
  int score, Tour, vague, Da, BVm, Diff;
  boolean QUIT, GAGNE, ESC;
  boolean Pa_OUVERTES, TOUCHE_D, MTir;
  char dirMx, dirMy;
  boolean[] Pressed = new boolean[18];
  boolean[] ATir = new boolean[6];
  t_Tir[] Bonnus = new t_Tir[3];
  t_coord[] XYa = new t_coord[7];
  t_Dir[] dbb = new t_Dir[3];
  t_Tir[] Tir = new t_Tir[MaxFire];

  int LINE;

//
//                            BASES GRAPHIQUES                              
//

  public void init_text_screen(Graphics g)
  { g.setColor(Color.black);
    g.fillRect(0, 0, 640, 400);
    g.setFont(new Font("arial", Font.BOLD, 14));
    g.setColor(new Color(0, 187, 0));
    LINE = 0;
  }

//

  public void writeln(Graphics g, String line)
  { LINE++;
    g.drawString(line, 20, 20 + (LINE * 20));     
  }

//

  public void Clear(Graphics g, Color c)
  { g.setColor(Color.black);
    g.fillRect(0, 370, 640, 379); 
    g.setColor(c);
    g.fillRect(0, 0, 640, 369);
    g.fillRect(0, 380, 640, 400);
  }

//

  public void Pt(Graphics g, int x, int y, Color color)
  { g.setColor(color);
    g.fillRect(x * 2, y * 2, 2, 2);
  }

//
//                            DIALOGUE CLAVIER                              
//

  public void keyPressed(KeyEvent e)
  { switch(e.getKeyCode())
    { case KeyEvent.VK_ESCAPE: Pressed[ESC_KEY] = true; break;
      case KeyEvent.VK_1: Pressed[_1_KEY] = true; break;
      case KeyEvent.VK_2: Pressed[_2_KEY] = true; break;
      case KeyEvent.VK_3: Pressed[_3_KEY] = true; break;
      case KeyEvent.VK_Q: Pressed[Q_KEY] = true; break;
      case KeyEvent.VK_C: Pressed[C_KEY] = true; break;
      case KeyEvent.VK_N: Pressed[N_KEY] = true; break;
      case KeyEvent.VK_Y: Pressed[Y_KEY] = true; break;
      case KeyEvent.VK_I: Pressed[I_KEY] = true; break;
      case KeyEvent.VK_P: Pressed[P_KEY] = true; break;
      case KeyEvent.VK_SPACE: Pressed[SP_KEY] = true; break;
      case KeyEvent.VK_F: Pressed[F_KEY] = true; break;
      case KeyEvent.VK_M: Pressed[M_KEY] = true; break;
      case KeyEvent.VK_K: Pressed[K_KEY] = true; break;
      case KeyEvent.VK_UP: Pressed[UP_KEY] = true; break;
      case KeyEvent.VK_DOWN: Pressed[DOWN_KEY] = true; break;
      case KeyEvent.VK_LEFT: Pressed[LEFT_KEY] = true; break;
      case KeyEvent.VK_RIGHT: Pressed[RIGHT_KEY] = true;
    }
    if(e.getKeyChar() == '1') Pressed[_1_KEY] = true;
    if(e.getKeyChar() == '2') Pressed[_2_KEY] = true;
    if(e.getKeyChar() == '3') Pressed[_3_KEY] = true;
  }

//

  public void keyReleased(KeyEvent e)
  { switch(e.getKeyCode())
    { case KeyEvent.VK_ESCAPE: Pressed[ESC_KEY] = false; break;
      case KeyEvent.VK_1: Pressed[_1_KEY] = false; break;
      case KeyEvent.VK_2: Pressed[_2_KEY] = false; break;
      case KeyEvent.VK_3: Pressed[_3_KEY] = false; break;
      case KeyEvent.VK_Q: Pressed[Q_KEY] = false; break;
      case KeyEvent.VK_C: Pressed[C_KEY] = false; break;
      case KeyEvent.VK_N: Pressed[N_KEY] = false; break;
      case KeyEvent.VK_Y: Pressed[Y_KEY] = false; break;
      case KeyEvent.VK_I: Pressed[I_KEY] = false; break;
      case KeyEvent.VK_P: Pressed[P_KEY] = false; break;
      case KeyEvent.VK_SPACE: Pressed[SP_KEY] = false; break;
      case KeyEvent.VK_F: Pressed[F_KEY] = false; break;
      case KeyEvent.VK_M: Pressed[M_KEY] = false; break;
      case KeyEvent.VK_K: Pressed[K_KEY] = false; break;
      case KeyEvent.VK_UP: Pressed[UP_KEY] = false; break;
      case KeyEvent.VK_DOWN: Pressed[DOWN_KEY] = false; break;
      case KeyEvent.VK_LEFT: Pressed[LEFT_KEY] = false; break;
      case KeyEvent.VK_RIGHT: Pressed[RIGHT_KEY] = false;
    }
    if(e.getKeyChar() == '1') Pressed[_1_KEY] = false;
    if(e.getKeyChar() == '2') Pressed[_2_KEY] = false;
    if(e.getKeyChar() == '3') Pressed[_3_KEY] = false;
  }

//

  public void keyTyped(KeyEvent e) {}


//

  public int Touche()
  { int Touche = -1;
    for(int i = 0; i < Pressed.length; i++)if(Pressed[i]) Touche = i;
    return Touche;
  }

//
//                               TEXTES                                     
//

  public void Sauves(Graphics g)
  { int t;
    init_text_screen(g);
    writeln(g, "                                      OUF ! NOUS VOILA SAUVES ...");
    _MenuP(g);
  }

//

  public void _MenuP(Graphics g)
  { writeln(g, "");
    writeln(g, "   LEFT............LEFT KEY");
    writeln(g, "   RIGHT...........RIGHT KEY");
    writeln(g, "   UP..............UP KEY");
    writeln(g, "   DOWN............DOWN_KEY");writeln(g, "");
    writeln(g, "   FIRE............SPACE-BAR");
    writeln(g, "   FLASH...........F");writeln(g, "");writeln(g, "");
    writeln(g, "   NEW GAME........N");writeln(g, "");writeln(g, "");writeln(g, "");
    writeln(g, "                                                       Good Luck ...");
    writeln(g, "");
    writeln(g, "SCORE : " + score);
  }

//

  public void GameOver(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                             G A M E     O V E R");
    writeln(g, "");
    writeln(g, "                            Play Again ?  ( Y / N )");
    for(int i = 1; i < 8; i++) writeln(g, "");
    writeln(g, "SCORE : " + score);
  }

//

  public void Intro(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 4; i++) writeln(g, "");
    writeln(g, "                      W O R M I T ' S     I N V A S I O N");
    writeln(g, "");writeln(g, "");writeln(g, "");
    writeln(g, "                 ATTENTION : Les wormits attaquent ! Si un seul");
    writeln(g, "                 d'entre eux atteint le sol terrestre , c'en");
    writeln(g, "                 est fini de l'espce humaine ...");
    writeln(g, "");
    writeln(g, "                 VOTRE MISSION : Sauver le monde pendant qu'il ");
    writeln(g, "                 en est encore temps .");
  }

//

  public void MenuP(Graphics g)
  { init_text_screen(g);
    writeln(g, "");
    _MenuP(g);
  }

//

  public void Vague1(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                   VOUS VENEZ D'EXTERMINER LA PREMIERE");
    writeln(g, "                            VAGUE D'ALIENS");
  }

//

  public void Vague2(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                   VOUS VENEZ D'EXTERMINER LA DEUXIEME");
    writeln(g, "                            VAGUE D'ALIENS");
  }

//

  public void Vague3(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                  BRAVOS VOUS AVEZ SAUVE L'ESPECE HUMAINE");
  }

//

  public void Alert(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                              A L E R T E  !");
    writeln(g, "");writeln(g, "");
    writeln(g, "                     ANIMAL  MONSTRUEUX  EN  APPROCHE  ...");
  }

//

  public void Difficulte(Graphics g)
  { int t; 
    init_text_screen(g);
    for(int i = 1; i < 7; i++) writeln(g, "");
    writeln(g, "                              EASY............1");
    writeln(g, "                              HARD............2");
    writeln(g, "                              SUPER-HERO......3");
  }

//
//                              DESSINS                                     
//

  public void drawBonnus(Graphics g, int x, int y, int typ)
  { Color c1 = new Color(140, 0, 0);
    Color c2 = new Color(187, 0, 0);
    Color c3 = new Color(255, 0, 0);
    if(typ == PLASMA)
    { c1 = new Color(0, 0, 140);
      c2 = new Color(0, 0, 187);
      c3 = new Color(0, 0, 255);
    }
    else if(typ == LASER)
    { c1 = new Color(0, 0, 0);
      c2 = new Color(78, 78, 78);
      c3 = new Color(139, 139, 139);
    }
    else if(typ == FLASH)
    { c1 = new Color(98, 98, 98);
      c2 = new Color(159, 159, 159);
      c3 = new Color(206, 206, 206);
    }
                              Pt(g, x-1,y-3,c1);Pt(g, x,y-3,c2);Pt(g, x+1,y-3,c2);Pt(g, x+2,y-3,c2);
               Pt(g, x-2,y-2,c1);Pt(g, x-1,y-2,c2);Pt(g, x,y-2,c2);Pt(g, x+1,y-2,c3);Pt(g, x+2,y-2,c3);Pt(g, x+3,y-2,c3);
Pt(g, x-3,y-1,c1);Pt(g, x-2,y-1,c2);Pt(g, x-1,y-1,c2);Pt(g, x,y-1,c3);Pt(g, x+1,y-1,c3);Pt(g, x+2,y-1,c3);Pt(g, x+3,y-1,c3);Pt(g, x+4,y-1,c3);
Pt(g, x-3,y,c1)  ;Pt(g, x-2,y,c2)  ;Pt(g, x-1,y,c2)  ;Pt(g, x,y,c3)  ;Pt(g, x+1,y,c3)  ;Pt(g, x+2,y,c3)  ;Pt(g, x+3,y,c3)  ;Pt(g, x+4,y,c3)  ;
Pt(g, x-3,y+1,c1);Pt(g, x-2,y+1,c1);Pt(g, x-1,y+1,c2);Pt(g, x,y+1,c2);Pt(g, x+1,y+1,c3);Pt(g, x+2,y+1,c3);Pt(g, x+3,y+1,c3);Pt(g, x+4,y+1,c3);
               Pt(g, x-2,y+2,c1);Pt(g, x-1,y+2,c1);Pt(g, x,y+2,c2);Pt(g, x+1,y+2,c2);Pt(g, x+2,y+2,c3);Pt(g, x+3,y+2,c3);
                              Pt(g, x-1,y+3,c1);Pt(g, x,y+3,c1);Pt(g, x+1,y+3,c1);Pt(g, x+2,y+3,c1);
  }

//}

  public void Un(Graphics g, int x, int y, Color c)
  { for(int i = y; i <= (y+6); i++) Pt(g, x,i,c);
    Pt(g, x-1,y+1,c);Pt(g, x-2,y+2,c);
  }

//}

  public void Deux(Graphics g, int x, int y, Color c)
  { Pt(g, x-2,y+1,c);Pt(g, x-1,y,c);Pt(g, x,y,c);Pt(g, x+1,y+1,c);
    Pt(g, x+1,y+2,c);Pt(g, x,y+3,c);Pt(g, x-1,y+4,c);
    for(int i = x-2; i <= x+1; i++) Pt(g, i,y+5,c);
  }

//}

  public void Trois(Graphics g, int x, int y, Color c)
  { Pt(g, x-2,y+1,c);Pt(g, x-1,y,c);Pt(g, x,y,c);Pt(g, x+1,y+1,c);
    Pt(g, x+1,y+2,c);Pt(g, x,y+3,c);Pt(g, x+1,y+4,c);
    for(int i = x-2; i <= x+1; i++) Pt(g, i,y+5,c);
  }

//}

  public void Quatre(Graphics g, int x, int y, Color c)
  { Pt(g, x,y,c);Pt(g, x-1,y+1,c);Pt(g, x-2,y+2,c);
    Pt(g, x-2,y+3,c);Pt(g, x,y+3,c);Pt(g, x,y+5,c);
    for(int i = x-2; i <= x+1; i++) Pt(g, i,y+4,c);
  }

//}

  public void Cinq(Graphics g, int x, int y, Color c)
  { Pt(g, x-2,y+1,c);Pt(g, x+1,y+3,c);Pt(g, x+1,y+4,c);
    for(int i = x-2; i <= x+1; i++) Pt(g, i,y,c);
    for(int i = x-2; i <= x; i++) Pt(g, i,y+2,c);
    for(int i = x-2; i <= x; i++) Pt(g, i,y+5,c);
  }

//}


  public void Six(Graphics g, int x, int y, Color c)
  { Pt(g, x-2,y+1,c);Pt(g, x+1,y+3,c);Pt(g, x+1,y+4,c);
    Pt(g, x-2,y+4,c);Pt(g, x-2,y+3,c);
    for(int i = x-1; i <= x+1; i++) Pt(g, i,y,c);
    for(int i = x-2; i <= x; i++) Pt(g, i,y+2,c);
    for(int i = x-1; i <= x; i++) Pt(g, i,y+5,c);
  }

//}

  public void Sept(Graphics g, int x, int y, Color c)
  { Pt(g, x,y+2,c);Pt(g, x,y+3,c);Pt(g, x+1,y+1,c);
    Pt(g, x-1,y+4,c);Pt(g, x-1,y+5,c);
    for(int i = x-2; i <= x+1; i++) Pt(g, i,y,c);
  }

//}

  public void Huit(Graphics g, int x, int y, Color c)
  { Pt(g, x,y,c);Pt(g, x-1,y,c);Pt(g, x+1,y+1,c);
    Pt(g, x-2,y+1,c);Pt(g, x-1,y+2,c);Pt(g, x,y+2,c);
    Pt(g, x+1,y+3,c);Pt(g, x-2,y+3,c);Pt(g, x+1,y+4,c);
    Pt(g, x-2,y+4,c);Pt(g, x-1,y+5,c);Pt(g, x,y+5,c);
  }

//}

  public void Neuf(Graphics g, int x, int y, Color c)
  { Pt(g, x,y,c);Pt(g, x-1,y,c);Pt(g, x+1,y+1,c);
    Pt(g, x-2,y+1,c);Pt(g, x-1,y+2,c);Pt(g, x,y+2,c);
    Pt(g, x+1,y+3,c);Pt(g, x+1,y+4,c);Pt(g, x+1,y+2,c);
    Pt(g, x-1,y+5,c);Pt(g, x,y+5,c);
  }

//}

  public void Zero(Graphics g, int x, int y, Color c)
  { Pt(g, x-1,y,c);Pt(g, x,y,c);
    Pt(g, x-1,y+5,c);Pt(g, x,y+5,c);
    for(int i = y+1; i <= y+4; i++) Pt(g, x-2,i,c);
    for(int i = y+1; i <= y+4; i++) Pt(g, x+1,i,c);
  }

//}

  public void Aff(Graphics g, int n, int p, Color c)
  { switch(n)
    { case 1 : Un(g, 10+p,192,c); break;
      case 2 : Deux(g, 10+p,192,c); break;
      case 3 : Trois(g, 10+p,192,c); break;
      case 4 : Quatre(g, 10+p,192,c); break;
      case 5 : Cinq(g, 10+p,192,c); break;
      case 6 : Six(g, 10+p,192,c); break;
      case 7 : Sept(g, 10+p,192,c); break;
      case 8 : Huit(g, 10+p,192,c); break;
      case 9 : Neuf(g, 10+p,192,c); break;
      case 0 : Zero(g, 10+p,192,c);
    }
  }

//}

  public void AffNb(Graphics g, int n, int y, Color c)
  { int n1,n2,n3;
    if(n<10) Aff(g, n,0+y,c);
    else
    { if(n<100)
      { n2 = n % 10;
        n1 = n / 10;
        Aff(g, n1,0+y,c);
        Aff(g, n2,6+y,c);
      }
      else
      { if(n<1000)
        { n1 = n / 100;
          n2 = (n % 100) / 10;
          n3 = (n % 100) % 10;
          Aff(g, n1,0+y,c);
          Aff(g, n2,6+y,c);
          Aff(g, n3,12+y,c);
        }
        else
        { Aff(g, 0,0+y,c);
          Aff(g, 0,6+y,c);
        }
      }
    }
  }

//}

  public void drawCroix(Graphics g, int x, int y, Color c)
  { Pt(g, x-2,y-2,c);Pt(g, x+2,y-2,c);
    Pt(g, x-1,y-1,c);Pt(g, x+1,y-1,c);
    Pt(g, x,y,c);
    Pt(g, x-1,y+1,c);Pt(g, x+1,y+1,c);
    Pt(g, x-2,y+2,c);Pt(g, x+2,y+2,c);
  }

//}

  public void AffFlash(Graphics g)
  { drawBonnus(g, 80,195,FLASH);
    drawCroix(g, 95,195,Color.gray);
    AffNb(g, nbFlash,98,Color.gray);
  }

//}

  public void drawSol(Graphics g)
  { Color c1 = new Color(91, 91, 91);
    Color c2 = Color.gray;
    Color c3 = Color.white;
    for(int i = 0; i <= 319; i++) Pt(g, i,184,c1);
    for(int i = 0; i <= 15; i++) Pt(g, i,140,c2);
    for(int i = 1; i <= 8 ; i++)
    { Pt(g, 2,i*5+140,c3);
      Pt(g, 3,i*5+140,c3);
      Pt(g, 4,i*5+140,c3);
      Pt(g, 5,i*5+140,c3);
      Pt(g, 9,i*5+140,c3);
      Pt(g, 10,i*5+140,c3);
      Pt(g, 11,i*5+140,c3);
      Pt(g, 12,i*5+140,c3);
    }
    for(int i = 141; i <= 183; i++) Pt(g, 15,i,c2);
    for(int i = 168; i <= 183; i++) Pt(g, 300,i,c2);
    for(int i = 301; i <= 319; i++) Pt(g, i,168,c2);
  }

//}


  public void drawS(Graphics g, int x, int y, boolean Hangar)
  { Color c1 = Color.red;
    Color c2 = Color.gray;
    Color c3 = Color.black;

    for(int i = x-7; i <= x+7; i++) Pt(g, i,y-1,c3);
    Pt(g, x-7,y,c3);Pt(g, x-6,y,c3);Pt(g, x-5,y,c3);
    Pt(g, x+7,y,c3);Pt(g, x+6,y,c3);Pt(g, x+5,y,c3);
    for(int i = y-5; i <= y-2 ; i++)
    { Pt(g, x-7,i,c3); Pt(g, x+7,i,c3);
    }
    for(int i = y-10; i <= y-2 ; i++)
    { Pt(g, x-2,i,c2); Pt(g, x+2,i,c2);
    }
    for(int i = x-1; i <= x+1 ; i++)
    { Pt(g, i,y-11,c3); Pt(g, i,y-10,c3);
    }
    Pt(g, x-6,y-2,c3);Pt(g, x-6,y-3,c3);Pt(g, x-5,y-4,c1);Pt(g, x-4,y-5,c1);Pt(g, x-3,y-6,c1);
    Pt(g, x+6,y-2,c3);Pt(g, x+6,y-3,c3);Pt(g, x+5,y-4,c1);Pt(g, x+4,y-5,c1);Pt(g, x+3,y-6,c1);

    if(!Hangar)
    { if(arme == NORMAL || arme == LASER)
      { c2 = Color.black;
        if(arme == NORMAL) c1 = Color.red;
        if(arme == LASER) c1 = Color.gray;
        for(int i = y-8; i <= y-3 ; i++)
        { Pt(g, x-1,i,c2);Pt(g, x,i,c1);Pt(g, x+1,i,c2);
        }
        for(int i = x-1; i <= x+1 ; i++)
        { Pt(g, i,y-9,c2);Pt(g, i,y-2,c2);
        }
      }
      if(arme == PLASMA)
      { c1 = Color.blue;
        for(int i = y-5; i <= y-2 ; i++)
        { Pt(g, x-3,i,c1); Pt(g, x+3,i,c1);
        }
        for(int i = y-4; i <= y-2 ; i++)
        { Pt(g, x-4,i,c1); Pt(g, x+4,i,c1);
        }
        for(int i = y-3; i <= y-2 ; i++)
        { Pt(g, x-5,i,c1); Pt(g, x+5,i,c1);
        }
      }
    }
  }

//}

  public void drawBVs(Graphics g)
  { int k = 20;
    Color c = Color.red;
    if(BVs>2) c = Color.green;
    for(int i = 0; i <= BVs-1 ; i++)
    { for(int j = 0; j <= k ; j++)
      { Pt(g, 317-((k*i)+j),193,c);
        Pt(g, 317-((k*i)+j),194,c);
        Pt(g, 317-((k*i)+j),195,c);
      }
    }
  }

//}

  public void drawBVm(Graphics g)
  { int k = 1;
    Color c = Color.red;
    if(BVm > 10) c = Color.green;
    for(int i = 0; i <= BVm-1; i++)
    { for(int j = 0; j <= k; j++)
      { Pt(g, 3,10+((k*i)+j),c);
        Pt(g, 4,10+((k*i)+j),c);
        Pt(g, 5,10+((k*i)+j),c);
      }
    }
  }

//}

  public void drawTs(Graphics g)
  { for(int i = 0; i < Tir.length; i++)
    { if(Tir[i].on) drawTs(g, i);
    }
  }

  public void drawTs(Graphics g, int ti)
  { int x = Tir[ti].x;
    int y = Tir[ti].y;
    int typ = Tir[ti].typ;
    int i;
    Color c1 = Color.red;
    Color c2 = Color.gray;
    Color c3 = Color.white;
         if(typ == NORMAL) { for(i = y-9; i <= y; i++) Pt(g, x,i,c1); }
    else if(typ == PLASMA)
    { for(i = y-8; i <= y-1; i++)
      { Pt(g, x-7,i,c2);Pt(g, x-3,i,c2);Pt(g, x+3,i,c2);Pt(g, x+7,i,c2);
      }
      Pt(g, x-6,y-7,c2);Pt(g, x-6,y-2,c2);Pt(g, x-4,y-7,c2);Pt(g, x-4,y-2,c2);
      Pt(g, x+6,y-7,c2);Pt(g, x+6,y-2,c2);Pt(g, x+4,y-7,c2);Pt(g, x+4,y-2,c2);

      for(i = y-9; i <= y; i++)
      { Pt(g, x-5,i,c3);Pt(g, x+5,i,c3);
        if(i != (y-2) && i  != y)
        {  Pt(g, x-6,i,c3);Pt(g, x-4,i,c3);Pt(g, x+4,i,c3);Pt(g, x+6,i,c3);
        }
      }
    }
    else if(typ == LASER)
    { for(i = 0; i <= y-1; i++)
      { Pt(g, x-2,i,c2);Pt(g, x+2,i,c2);
      }
      for(i = 0; i <= y-3; i++)
      { Pt(g, x-1,i,c3);Pt(g, x,i,c3);Pt(g, x+1,i,c3);
      }
      for(i = y-2; i <= y; i++) Pt(g, x,i,c3);
      Pt(g, x-1,i-2,c2);Pt(g, x-1,i-1,c3);Pt(g, x+1,i-2,c2);Pt(g, x+1,i-1,c3);
    }
  }

//}

  public void drawA(Graphics g, int x, int y, Color c, boolean b)
  { for(int i = x-1; i <= x+2; i++) Pt(g, i,y-4,c);
    for(int i = x-2; i <= x+3; i++) Pt(g, i,y-3,c);
    for(int i = x-3; i <= x+4; i++) Pt(g, i,y-2,c);
    Pt(g, x-4,y-1,c);Pt(g, x-3,y-1,c);Pt(g, x,y-1,c);
    Pt(g, x+1,y-1,c);Pt(g, x+4,y-1,c);Pt(g, x+5,y-1,c);
    for(int i = x-5; i <= x+6; i++) Pt(g, i,y,c);
    for(int i = x-4; i <= x+5; i++) Pt(g, i,y+1,c);
    Pt(g, x-2,y+2,c);Pt(g, x+3,y+2,c);
    Pt(g, x-3,y+3,c);Pt(g, x+4,y+3,c);
    if(b)
    { Pt(g, x-5,y+4,c);Pt(g, x-4,y+4,c);Pt(g, x-6,y+5,c);
      Pt(g, x+5,y+4,c);Pt(g, x+6,y+4,c);Pt(g, x+7,y+5,c);
    }
    else
    { Pt(g, x-2,y+4,c);Pt(g, x-1,y+4,c);Pt(g, x,y+5,c);
      Pt(g, x+2,y+4,c);Pt(g, x+3,y+4,c);Pt(g, x+1,y+5,c);
    }
  }

//}

  public void drawBB(Graphics g, int x, int y, Color c)
  { Pt(g, x,y-3,c);Pt(g, x+1,y-3,c);
    for(int i = x-1; i <= x+2; i++) Pt(g, i,y-2,c);
    for(int i = x-2; i <= x+3; i++) Pt(g, i,y-1,c);
    Pt(g, x-2,y,c);Pt(g, x,y,c);Pt(g, x+1,y,c);Pt(g, x+3,y,c);
    for(int i = x-2; i <= x+3; i++) Pt(g, i,y+1,c);
    Pt(g, x-1,y+2,c);Pt(g, x+2,y+2,c);Pt(g, x,y+3,c);Pt(g, x+1,y+3,c);
  }

//}

  public void drawM(Graphics g, int x, int y, Color c)
  { for(int i = x-2; i <= x+3; i++) Pt(g, i,y-5,c);
    for(int i = x-4; i <= x+5; i++) Pt(g, i,y-4,c);
    for(int i = x-6; i <= x+7; i++) Pt(g, i,y-3,c);
    Pt(g, x-6,y-2,c); Pt(g, x-5,y-2,c);
    for(int i = x-1; i <= x+2; i++) Pt(g, i,y-2,c);
    Pt(g, x+6,y-2,c); Pt(g, x+7,y-2,c);
    for(int i = x-6; i <= x+7; i++) Pt(g, i,y-1,c);
    for(int i = x-9; i <= x-6; i++) Pt(g, i,y,c);
    for(int i = x-2; i <= x+3; i++) Pt(g, i,y,c);
    for(int i = x+7; i <= x+10; i++) Pt(g, i,y,c);

    Pt(g, x-10,y+1,c);Pt(g, x,y+1,c);Pt(g, x+1,y+1,c);Pt(g, x+11,y+1,c);

    Pt(g, x-11,y+2,c);Pt(g, x-9,y+2,c);Pt(g, x-1,y+2,c);
    Pt(g, x+2,y+2,c);Pt(g, x+10,y+2,c);Pt(g, x+12,y+2,c);

    Pt(g, x-12,y+3,c);Pt(g, x-8,y+3,c);Pt(g, x-2,y+3,c);
    Pt(g, x+3,y+3,c);Pt(g, x+9,y+3,c);Pt(g, x+13,y+3,c);

    Pt(g, x-12,y+4,c);Pt(g, x-8,y+4,c);Pt(g, x-2,y+4,c);
    Pt(g, x+3,y+4,c);Pt(g, x+9,y+4,c);Pt(g, x+13,y+4,c);

    Pt(g, x-13,y+5,c);Pt(g, x-7,y+5,c);Pt(g, x-4,y+5,c);Pt(g, x-3,y+5,c);
    Pt(g, x+4,y+5,c);Pt(g, x+5,y+5,c);Pt(g, x+8,y+5,c);Pt(g, x+14,y+5,c);
  }

//}

  public void NewS(Graphics g)
  { int i;
    Clear(g, Bkc);
    drawSol(g);
    if(Xs>229)
    { for(i = 168; i <= 183; i++) Pt(g, 300,i,Bkc);
      for(i = 285; i <= 299; i++) Pt(g, i,168, Color.gray);
    }
    drawS(g, Xs,Ys,false);
    if(Vs>1)
    { if(Xs>289) drawS(g, Xs+20,Ys,true);
      else drawS(g, 309,Ys,true);
    }
    if(!ESC)
    { if(vague>2 || Diff>1) drawBVs(g);
      if(vague == 4) drawBVm(g);
    }
    AffFlash(g);
    AffNb(g, score,0, Color.gray);
  }

//}

  public void Draw(Graphics g)
  { Clear(g, Bkc);
    _Draw(g);
  }

  public void Flash(Graphics g)
  { Clear(g, Color.white);
    _Draw(g);
  }

  public void _Draw(Graphics g)
  { int i = 0;
    int j = 0;
    drawSol(g);
    if(vague < 4)
    { while(i < 3)
      { drawA(g, XYa[i].x, XYa[i].y, Color.green, Pa_OUVERTES);
        if(ATir[i])
        { for(j = XYa[i].y+7; j <= 183; j++)
          { if((j % 2) == 0) Pt(g, XYa[i].x,j, Color.green); else Pt(g, XYa[i].x+1,j, Color.green);
          }
          ATir[i] = false;
        }
        i++;
      }
    }
    else
    { drawM(g, XYa[6].x,XYa[6].y, Color.green);
      drawBVm(g);
      if(MTir)
      { for(i = XYa[6].y+4; i <= 183; i++)
        { Pt(g, XYa[6].x-10,i, Color.green);
          if((i % 2) == 0) Pt(g, XYa[6].x,i, Color.green); else Pt(g, XYa[6].x+1,i, Color.green);
          Pt(g, XYa[6].x+11,i, Color.green);
        }
        MTir = false;
      }
    }
    if(Diff>1)
    { for(i = 3; i < 6; i++)
      { drawBB(g, XYa[i].x, XYa[i].y, Color.green);
        if(ATir[i])
        { for(j = XYa[i].y+7; j <= 183; j++)
          { if((j % 2) == 0) Pt(g, XYa[i].x,j, Color.green); else Pt(g, XYa[i].x+1,j, Color.green);
          }
          ATir[i] = false;
        }
      }
    }
    for(i = 0; i < 3; i++)
    { if(Bonnus[i].on) drawBonnus(g, Bonnus[i].x, Bonnus[i].y, Bonnus[i].typ);
    }
    AffFlash(g);
    drawS(g, Xs,Ys,false);
    if(vague>2 || Diff>1) drawBVs(g);
    drawTs(g);
    AffNb(g, score,0,Color.gray);
    if(Vs>1) drawS(g, 309,183,true);
  }

//
//                               ECRANS                                 
//

  public void Sauves()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t != N_KEY);
  }

  public void GameOver()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t != Y_KEY && t != N_KEY);
    if(t == Y_KEY)
    { Vs = 3;
      BVs = 5;
      arme = 0;
      nbFlash = 0;
      BVm = Vm;
    }
  }

  public void Intro()
  { int t;
    do t = Touche(); while(!QUIT && t == -1);
  }

  public void MenuP()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t != N_KEY);
  }

  public void Vague1()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t == -1);
  }

  public void Vague2()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t == -1);
  }

  public void Vague3()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t == -1);
    wormit.Alert();
  }

  public void Alert()
  { int t;
    do t = Touche(); while(!QUIT && t != -1);
    do t = Touche(); while(!QUIT && t == -1);
  }

  public void Difficulte()
  { int t;
    do t = Touche(); while(!QUIT && t != _1_KEY && t != _2_KEY && t != _3_KEY);
    if(t == _1_KEY) Diff = 1;
    if(t == _2_KEY) Diff = 2;
    if(t == _3_KEY) Diff = 3;
  }

  public void Flash()
  { int t;
    do t = Touche(); while(t != -1);
  }

//
//                               ANIMATIONS                                 
//

//}

  public void Init()
  { GAGNE = false;
    ESC = false;
  }

//}

  public void InitGame()
  { vague = 1;
    Vs = 3;
    BVs = 5;
    arme = 0;
    nbFlash = 0;
    Da = 0;
    Tour = 0;
    score = 0;
    GAGNE = false;
    ESC = false;
    for(int i = 0; i < 3; i++)
    { Bonnus[i].x = -10;
      Bonnus[i].y = -10;
    }
  }

//}

  public void InitCoords()
  { int i,n;
    if(Diff == 1) n = 3; else n = 6;
    for(i = 0; i < n; i++) newCoord(i);
    newCoord(6);
    dirMx = 'd';
    dirMy = 'b';
    if(Diff>1)
    { for(i = 0; i < 3; i++)
      { dbb[i].x = 1;
        dbb[i].y = 1;
      }
    }
    Pa_OUVERTES = false;
    if(TOUCHE_D) arme = 0;
    TOUCHE_D = false;
    for(i = 0; i < 3; i++) Bonnus[i].on = false;
  }

//}

  public void newCoord(int i)
  { int n, k, p, marge;
    boolean OKpos;
    p = 0;
    marge = 20;
    if(i == 6)
    { XYa[i].x = 29;
      XYa[i].y = 5;
    }
    else
    { if(Diff == 1) n = 3; else n = 6;
      XYa[i].y = 4;
      OKpos = false;
      while(!OKpos)
      { OKpos = true;
        p = 22+ (int)(270 * Math.random());
        for(k = 0; k < n; k++)
        { if(p > (XYa[k].x-marge) && p < (XYa[k].x+marge)) OKpos = false;
        }
      }
    }
    XYa[i].x = p;
  }

//}

  public void NewS()
  { int i;
    for(i = 0; i < MaxFire; i++) Tir[i].on = false;
    Xs = 310;
    Ys = 183;
    while(Xs>150 && !ESC)
    { Xs--;
      if(Touche() == ESC_KEY) ESC = true;
      wormit.NewS();
      try{ sleep(sleep); } catch(Exception e) {}
    }
  }

//}

  public void MoveAlien()
  { if(vague == 4) MoveM(); else MoveA();
    if(Diff>1) MoveBB();
  }

//}

  public void MoveA()
  { int i;
    for(i = 0; i < 3; i++) ATir[i] = false;
    if(Tour % 2 == 0)
    { if(Tour % 8 == 0)
      { if(Pa_OUVERTES) Pa_OUVERTES = false; else Pa_OUVERTES = true;
      }
      i = 0;
      while(i < 3 && !TOUCHE_D)
      { if(vague == 3 && (30 * Math.random()) < 1) TirA(XYa[i].x,XYa[i].y, i);
        if(vague>1 && (Tour % 8) == 0) XYa[i].x = XYa[i].x-5+(int)(10*Math.random());
        if(XYa[i].x<22) XYa[i].x = 22;
        if(XYa[i].x>292) XYa[i].x = 292;
        XYa[i].y = XYa[i].y+1;
        if(XYa[i].y>178)
        { Vs--;
          TOUCHE_D = true;
        }
        i++;
      }
    }
  }

//}

  public void TirA(int x, int y, int a)
  { ATir[a] = true;
    if(x>(Xs-8) && x<(Xs+8) && Ys>(y+5))
    { BVs--;
      if(BVs == 0)
      { Vs--;
        BVs = 5;
        TOUCHE_D = true;
      }
    }
  }

//}

  public void MoveM()
  { if((15 * Math.random()) < 1)
    { if((2 * Math.random()) < 1)
      { if(dirMx == 'd') dirMx = 'g'; else dirMx = 'd';
      }
      else
      { if(dirMy == 'b') dirMx = 'h'; else dirMx = 'b';
      }
    }
    if(dirMx == 'd')
    { XYa[6].x = XYa[6].x+2;
      if(XYa[6].x>285)
      { XYa[6].x = 285;
        dirMx = 'g';
      }
    }
    if(dirMx == 'g')
    { XYa[6].x = XYa[6].x-2;
      if(XYa[6].x<29)
      { XYa[6].x = 29;
        dirMx = 'd';
      }
    }
    if(dirMy == 'b')
    { XYa[6].y = XYa[6].y+2;
      if(XYa[6].y>100)
      { XYa[6].y = 100;
        dirMy = 'h';
      }
    }
    if(dirMy == 'h')
    { XYa[6].y = XYa[6].y-2;
      if(XYa[6].y<5)
      { XYa[6].y = 5;
        dirMy = 'b';
      }
    }
    if((20 * Math.random()) < 1) TirM(XYa[6].x,XYa[6].y);
  }


//}

  public void TirM(int x, int y)
  { MTir = true;
    if(x>(Xs-19) && x<(Xs+18) && Ys>(y+5))
    { BVs--;
      if(BVs == 0)
      { BVs = 5;
        Vs--;
        TOUCHE_D = true;
      }
    }
  }


//}

  public void MoveBB()
  { int i, k, nd, nf, g, d, h, b;
    g = d = h = b = 0;
    for(i = 3; i < 6; i++)
    { if(Diff == 3 && (30 * Math.random()) < 1) TirA(XYa[i].x,XYa[i].y, i);
      XYa[i].y = XYa[i].y+dbb[i-3].y;
      XYa[i].x = XYa[i].x+dbb[i-3].x;
      if(XYa[i].y>178)
      { XYa[i].y = 178;
        dbb[i-3].y = -1;
      }
      if(XYa[i].y<3)
      { XYa[i].y = 3;
        dbb[i-3].y = 1;
      }
      if(XYa[i].x>296)
      { XYa[i].x = 296;
        dbb[i-3].x = -1;
      }
      if(XYa[i].x<18)
      { XYa[i].x = 18;
        dbb[i-3].x = 1;
      }
      if(vague == 4)
      { nd = 3;
        nf = 6;
      }
      else
      { nd = 0;
        nf = 5;
      }
      for(k = nd; k <= nf; k++)
      { if(k != i)
        { if(k<4)
          { d = 6;
            g = 7;
            h = 4;
            b = 5;
          }
          if(k>3 && k != 7)
          { d = 2;
            g = 3;
            h = 3;
            b = 3;
          }
          if(k == 7)
          { d = 13;
            g = 14;
            h = 5;
            b = 5;
          }
          if((XYa[i].x+3)>=(XYa[k].x-g) && (XYa[i].x-2)<=(XYa[k].x+d)
             && (XYa[i].y+3)>=(XYa[k].y-h) && (XYa[i].y-3)<=(XYa[k].y+b))
          { if ((XYa[i].x-2)<(XYa[k].x-g))
            { XYa[i].x = XYa[k].x-g-4;
              dbb[i-3].x = -1;
            }
            if((XYa[i].x+3)>(XYa[k].x+d))
            { XYa[i].x = XYa[k].x+d+3;
              dbb[i-3].x = 1;
            }
            if((XYa[i].y-3)<(XYa[k].y-h))
            { XYa[i].y = XYa[k].y-h-4;
              dbb[i-3].y = -1;
            }
            if((XYa[i].y+3)>(XYa[k].y+b))
            { XYa[i].y = XYa[k].y+b+4;
              dbb[i-3].y = 1;
            }
          }
        }
      }
      if ((XYa[i].x+3)>=(Xs-7) && (XYa[i].x-2)<=(Xs+7)
             && (XYa[i].y+3)>=(Ys-11) && (XYa[i].y-3)<=Ys)
      { if ((XYa[i].x-2)<(Xs-7))
        { XYa[i].x = Xs-11;
          dbb[i-3].x = -1;
          BVs--;
          if(BVs == 0)
          { Vs--;
            BVs = 5;
            TOUCHE_D = true;
          }
        }
        if((XYa[i].x+3)>(Xs+7))
        { XYa[i].x = Xs+10;
          dbb[i-3].x = 1;
          BVs--;
          if(BVs == 0)
          { Vs--;
            BVs = 5;
            TOUCHE_D = true;
          }
        }
        if((XYa[i].y-3)<(Ys-11))
        { XYa[i].y = Ys-15;
          dbb[i-3].y = -1;
          BVs--;
          if(BVs == 0)
          { Vs--;
            BVs = 5;
            TOUCHE_D = true;
          }
        }
        if((XYa[i].y+3)>Ys)
        { XYa[i].y = Ys+4;
          dbb[i-3].y = 1;
          BVs--;
          if(BVs == 0)
          { Vs--;
            BVs = 5;
            TOUCHE_D = true;
          }
        }
      }
    }
  }

//}

  public void MoveB()
  { int i;
    for(i = 0; i < 3; i++)
    { Bonnus[i].y++;
      if(Bonnus[i].y>180)
      { Bonnus[i].on = false;
        Bonnus[i].x = -10;
        Bonnus[i].y = -10;
      }
      else
      { if((Xs+7)>=(Bonnus[i].x-3) && (Xs-7)<=(Bonnus[i].x+4)
           && (Ys)>=(Bonnus[i].y-3) && (Ys-11)<=(Bonnus[i].y+3))
        { Bonnus[i].on = false;
          Bonnus[i].x = -10;
          Bonnus[i].y = -10;
          if(Bonnus[i].typ != FLASH)
          { if(arme == LASER) Tir[0].on = false;
            arme = Bonnus[i].typ;            
          }
          else nbFlash++;
        }
      }
    }
  }

//
//                               SHIP                                       
//

  public void MoveS()
  { int i, t;
    if(Pressed[LEFT_KEY] || Pressed[RIGHT_KEY]
      || Pressed[UP_KEY] || Pressed[DOWN_KEY])
    { if(Pressed[LEFT_KEY]) Xs = Xs-2;
      if(Pressed[RIGHT_KEY]) Xs = Xs+2;
      if(Pressed[UP_KEY]) Ys = Ys-2;
      if(Pressed[DOWN_KEY]) Ys = Ys+2;
      if(Xs>292) Xs = 292;
      if(Xs<23) Xs = 23;
      if(Ys>183) Ys = 183;
      if(Ys<11) Ys = 11;
    }
    if(Pressed[SP_KEY])
    { if(arme == LASER)
      { Tir[0].on = true;
        Tir[0].x = Xs;
        Tir[0].y = Ys-13;
        Tir[0].typ = arme;
      }
      else if((Tour % 7) == 0)
      { i = 1;
        while(Tir[i].on && i < MaxFire) i++;
        if(i < MaxFire)
        { Tir[i].on = true;
          Tir[i].x = Xs;
          Tir[i].y = Ys-13;
          Tir[i].typ = arme;
        }
      }
    }
    else if(arme == LASER) Tir[0].on = false;
    MoveT();
    if(Pressed[F_KEY] && nbFlash>0)
    { wormit.Flash();
      for(i = 0; i < 3; i++) newCoord(i);
      score += 6;
      if(vague == 4)
      { BVm -= 10;
        score += 20;
      }
      if(Diff>1)
      { score += 9;
        for(i = 3; i < 6; i++) newCoord(i);
      }
      nbFlash--;
    }
    if(Pressed[P_KEY])
    { do t = Touche(); while(t != -1);
      do t = Touche(); while(t == -1);
    }
    if(Pressed[ESC_KEY]) ESC = true;
  }

//}

  public void MoveT()
  { int i, k, j;
    boolean NEW = false;
    i = 0;
    while(i<MaxFire && !NEW)
    { if(Tir[i].on)
      { if(Tir[i].typ != LASER)
        { Tir[i].y -= 2;
          if(Tir[i].y<0) Tir[i].on = false;
        }
        if(Tir[i].on)
        { if(vague<4)
          { k = 0;
            while(k<3 && !NEW)
            { if(tirToucheAlien(i,k))
              { Da++;
                score += 2;
                Tir[i].on = false;
                if((5 * Math.random()) < 1)
                { j = 0;
                  while(j<3 && Bonnus[j].on) j++;
                  if(j<3)
                  { Bonnus[j].x = XYa[k].x;
                    Bonnus[j].y = XYa[k].y;
                    Bonnus[j].on = true;
                    Bonnus[j].typ = (int)(4 * Math.random());
                  }
                }
                newCoord(k);
                if(vague == 1 && Da >= na1)
                { NEW = true;
                  Da = 0;
                  vague = 2;
                  wormit.Vague1();
                  InitCoords();
                  NewS();
                }
                if(vague == 2 && Da >= na2)
                { NEW = true;
                  Da = 0;
                  vague = 3;
                  wormit.Vague2();
                  InitCoords();
                  NewS();
                }
                if(vague == 3 && Da >= na3)
                { NEW = true;
                  Da = 0;
                  vague = 4;
                  BVm = Vm;
                  wormit.Vague3();
                  InitCoords();
                  NewS();
                }
              }
              k++;
            }
          }
          else
          { if(tirToucheAlien(i,6))
            { if(arme == NORMAL)
              { BVm--;
                score += 2;
              }
              if(arme == PLASMA)
              { BVm -= 3; 
                score += 6;
              }
              if(arme == LASER)
              { BVm -= 2;
                score += 4;
              }
              Tir[i].on = false;
              if(BVm == 0) GAGNE = true;
            }
          }
          if(Diff>1 && !NEW)
          { for(k = 3; k < 6; k++)
            { if(tirToucheAlien(i,k))
              { newCoord(k);
                score += 3;
                Tir[i].on = false;
              }
            }
          }
        }
      }
      i++;
    }
  }

//}

  public boolean tirToucheAlien(int ti, int a)
  { int x, y, l, a_G, a_D, a_H, a_B;
    a_G = a_D = a_H = a_B = l =0;
    boolean tirToucheAlien = false;
    x = Tir[ti].x;
    y = Tir[ti].y;
    if(a<4)
    { a_G = XYa[a].x-6;
      a_D = XYa[a].x+7;
      a_H = XYa[a].y-4;
      a_B = XYa[a].y+5;
    }
    else if(a>3 && a<7)
    { a_G = XYa[a].x-2;
      a_D = XYa[a].x+3;
      a_H = XYa[a].y-3;
      a_B = XYa[a].y+3;
    }
    else if(a==7)
    { a_G = XYa[a].x-13;
      a_D = XYa[a].x+14;
      a_H = XYa[a].y-5;
      a_B = XYa[a].y+5;
    }
    if(Tir[ti].typ<2)
    { if(Tir[ti].typ == 0) l = 0;
      if(Tir[ti].typ == 1) l = 7;
      if((x+l)>=a_G && (x-l)<=a_D && (y-9)<=a_B && y>=a_H) tirToucheAlien = true;
    }
    if(Tir[ti].typ == LASER)
    { if((x+2)>=a_G && (x-2)<=a_D && y>=a_H) tirToucheAlien = true;
    }
    return tirToucheAlien;
  }

//
//                               PROGRAMME                                  
//

  public void run()
  { Init();
    wormit.Intro();
    while(!QUIT)
    { if(GAGNE) wormit.Sauves(); else wormit.MenuP();
      if(!QUIT) 
      { wormit.Difficulte();
        InitGame();
        while(!ESC && Vs != 0 && !GAGNE)
        { InitCoords();
          NewS();
          while(!ESC && !TOUCHE_D && Vs != 0 && !GAGNE)
          { MoveAlien();
            MoveS();
            MoveB();
            wormit.Draw();
            try{ sleep(sleep); } catch(Exception e) {}
            Tour++; if(Tour > 100) Tour = 0;
          }
          if(Vs == 0) wormit.GameOver();
        }
      }
    }
  }

  public void end() { QUIT = true; }

}

