package wormit;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;

public class Wormit extends Applet
{
  final int SAUVES     = 1;
  final int GAMEOVER   = 2;
  final int INTRO      = 3;
  final int MENUP      = 4;
  final int VAGUE1     = 5;
  final int VAGUE2     = 6;
  final int VAGUE3     = 7;
  final int ALERT      = 8;
  final int DIFFICULTE = 9;
  final int NEWS       = 10;
  final int DRAW       = 11;
  final int FLASH      = 12;
  int STATE;

  Game game;

  Graphics graphics_buffer;
  Image image_buffer;

  public void init()
  { game = new Game(this);
    addKeyListener(game);
  }

  public void start() { game.start(); }
  public void dispose() { game.end(); }

  public void update(Graphics g)
  { if(image_buffer == null)
    { image_buffer = createImage(size().width, size().height);
      graphics_buffer = image_buffer.getGraphics();
    }
    paint(graphics_buffer);
    g.drawImage(image_buffer, 0, 0, this);
  }

  public void Sauves() { STATE = SAUVES; repaint(); game.Sauves(); }
  public void GameOver() { STATE = GAMEOVER; repaint(); game.GameOver(); }
  public void Intro() { STATE = INTRO; repaint(); game.Intro(); }
  public void MenuP() { STATE = MENUP; repaint(); game.MenuP(); }
  public void Vague1() { STATE = VAGUE1; repaint(); game.Vague1(); }
  public void Vague2() { STATE = VAGUE2; repaint(); game.Vague2(); }
  public void Vague3() { STATE = VAGUE3; repaint(); game.Vague3(); }
  public void Alert() { STATE = ALERT; repaint(); game.Alert(); }
  public void Difficulte() { STATE = DIFFICULTE; repaint(); game.Difficulte(); }
  public void NewS() { STATE = NEWS; repaint(); }
  public void Draw() { STATE = DRAW; repaint(); }
  public void Flash() { STATE = FLASH; repaint(); game.Flash(); }

  public void paint(Graphics g)
  { switch(STATE)
    { case SAUVES: game.Sauves(g); break;
      case GAMEOVER: game.GameOver(g); break;
      case INTRO: game.Intro(g); break;
      case MENUP: game.MenuP(g); break;
      case VAGUE1: game.Vague1(g); break;
      case VAGUE2: game.Vague2(g); break;
      case VAGUE3: game.Vague3(g); break;
      case ALERT: game.Alert(g); break;
      case DIFFICULTE: game.Difficulte(g); break;
      case NEWS: game.NewS(g); break;
      case DRAW: game.Draw(g); break;
      case FLASH: game.Flash(g);
    }
  }

}

